<template>
    <div>

        <div>Pedido da vez</div>
        <v-row>
            <v-col>
                <p class="display-4 font-weight-bold text--primary">{{zerosEsquerda(pedidoSelecionado.id)}}</p>
            </v-col>
            <v-col>

                <v-form ref="form" lazy-validation>
                    <v-row justify="center" no-gutters>
                        <v-col>
                            <v-text-field v-model="responsavel" label="Responsável" outlined required></v-text-field>
                        </v-col>
                        <v-col>
                            <v-btn color="success" class="mr-4 btn-validate-start" @click="btnStartPedido();">
                                Start
                            </v-btn>
                        </v-col>
                    </v-row>
                </v-form>

            </v-col>
        </v-row>

        <div class="detalhe-pedido" v-show="true">
            <v-row>
             
                <Hamburguer v-show="blTipoHamburguer" :objHamburguer="objHamburguer"/> <Refri v-show="blTipoRefri" :objRefri="objRefri"/>

            </v-row>
            <br><br>
            <v-row>

                <Alfajor v-show="blTipoAlfajor" :objAlfajor="objAlfajor"/> <Molho v-show="blTipoMolho" :objMolho="objMolho"/>

            </v-row>

        </div>

        <v-snackbar v-model="snackbarStart" :timeout="timeout">
            {{ text }}
            <v-btn color="white" text @click="snackbarStart = false">
                Close
            </v-btn>
        </v-snackbar>

    </div>

</template>

<script>
    import Hamburguer from '@/components/Pedido/Hamburguer.vue'
    import Refri from '@/components/Pedido/Refri.vue'
    import Alfajor from '@/components/Pedido/Alfajor.vue'
    import Molho from '@/components/Pedido/Molho.vue'

    export default {
        name: 'Pedido',
        inject: ['getCarrinho','zerosEsquerda','getNomeProduto'],
        props: [
            'pedidoSelecionado',
            'carrinhoSelecionado',
            'produtos'
        ],
        components: {
            Hamburguer,Refri,Alfajor,Molho
        },
        data() {
            return {
                responsavel: '',
                teste: null,
                snackbarStart: false,
                text: 'Start!!!',
                timeout: 2000,
                carrinhoTratado: [],
                show: false,
                blTipoHamburguer: false,
                blTipoRefri: false,
                blTipoAlfajor: false,
                blTipoMolho: false,
                objHamburguer: {
                    quantidade: 0,
                    observacao: ''
                },
                objRefri: {
                    quantidade: 0,
                    itens: []
                },
                objAlfajor: {
                    quantidade: 0
                },
                objMolho: {
                    quantidade: 0,
                    itens: []
                }
            }
        },
        watch: {
            pedidoSelecionado: function () {
                console.log("Pedido watch pedidoSelecionado");
                this.getCarrinho();
            },
            carrinhoSelecionado: function () {
                console.log("Pedido watch carrinhoSelecionado");
                this.arrumaCarrinho();
            }
        },
        methods: {
            btnStartPedido: function () {
                console.log("btnStartPedido");

                //recebe "Responsável"
                if (this.responsavel == '' || this.responsavel == null) {
                    this.text = 'Informe um Responsável';
                    this.snackbarStart = true;
                    return false;
                }

                //chama serviço para cadastrar o "Responsável" no pedido
                this.iniciaPedido(this.pedidoSelecionado.id, this.responsavel);
                //atualiza pedido na tela
                this.$nextTick(() => {
                    this.selecionaProximoPedido();
                    this.responsavel = "";
                });
                //atualiza lista de pedidos pendentes/concluídos
                // this.atualizaListasPedidos();

                //exibe status da tela
                this.text = 'Start ' + this.responsavel + '!!!';
                this.snackbarStart = true;
                this.responsavel = "";
            },
            iniciaPedido: function (id, responsavel) {
                console.log("Pedido iniciaPedido", 'id: ' + id + ' responsavel: ' + responsavel);
                this.$parent.$parent.iniciarPedido(id, responsavel);
            },
            selecionaProximoPedido: function () {
                console.log("Pedido selecionaProximoPedido");
                this.$parent.$parent.selecionaProximoPedido();
            },
            atualizaListasPedidos: function () {
                console.log("Pedido atualizaListasPedidos");
                this.$parent.$parent.getPedidos();
            },
            arrumaCarrinho: function () {
                console.log("Pedido arrumaCarrinho", this.carrinhoSelecionado);

                this.blTipoHamburguer = false;
                this.blTipoRefri = false;
                this.blTipoAlfajor = false;
                this.blTipoMolho = false;

                let ham = {
                    quantidade: 0,
                    observacao: '',
                };
                let alfa = {
                    quantidade: 0
                };
                let refri = {
                    quantidade: 0,
                    itens: []
                };
                let molho = {
                    quantidade: 0,
                    itens: []
                };

                this.carrinhoSelecionado.dados.filter(c => {
                    if (c.tipo_produto_id == 1) 
                        this.blTipoHamburguer = true;
                    if (c.tipo_produto_id == 2) 
                        this.blTipoRefri = true;
                    if (c.tipo_produto_id == 3)
                        this.blTipoAlfajor = true;
                    if (c.tipo_produto_id == 4) 
                        this.blTipoMolho = true;

                    if (c.tipo_produto_id == 1) {
                        ham.quantidade += c.quantidade;
                        if (c.observacao != null)
                            ham.observacao = ham.observacao + ' ' + c.observacao;
                    }

                    if (c.tipo_produto_id == 3) {
                        alfa.quantidade += c.quantidade
                    }

                    if (c.tipo_produto_id == 2) {
                        refri.quantidade += c.quantidade;
                        refri.itens.push({'quantidade': c.quantidade,'nome':c.produto_id});
                        console.log("refri",refri);
                    }

                    if (c.tipo_produto_id == 4) {

                        molho.quantidade += c.quantidade;
                        molho.itens.push({'quantidade': c.quantidade, 'nome': c.produto_id});
                    }
                });

                this.objHamburguer = ham;
                this.objAlfajor = alfa;
                this.objRefri = refri;
                this.objMolho = molho;
            },
        }
    }
</script>

<style lang="scss">
    .td-produto {
        padding: 0 10px;
    }

    .btn-atualizar-lista-pedidos {
        margin-bottom: 20px;
    }

    .left {
        float: left;
    }

    .btn-validate-start {
        margin-left: 20px;
    }
</style>